<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/process.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/process.py</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/process.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2003 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">from</span> Processor <span class="py-keyword">import</span> Processor, Error</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">import</span> IR</span>
<a id="line10"></a><span class="lineno">10</span><span class="line"><span class="py-keyword">from</span> getoptions <span class="py-keyword">import</span> get_options</span>
<a id="line11"></a><span class="lineno">11</span>
<a id="line12"></a><span class="lineno">12</span><span class="line"><span class="py-keyword">import</span> sys</span>
<a id="line13"></a><span class="lineno">13</span>
<a id="line14"></a><span class="lineno">14</span><span class="line"><span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/process.html#error">error</a>(msg):</span>
<a id="line15"></a><span class="lineno">15</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Write an error message and exit.&quot;&quot;&quot;</span></span>
<a id="line16"></a><span class="lineno">16</span><span class="line">    sys.stderr.write(msg)</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">    sys.stderr.write(<span class="py-string">'\n'</span>)</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">    sys.exit(-1)</span>
<a id="line19"></a><span class="lineno">19</span>
<a id="line20"></a><span class="lineno">20</span><span class="line"><span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/process.html#process">process</a>(argv = sys.argv, **commands):</span>
<a id="line21"></a><span class="lineno">21</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Accept a set of commands and process according to command line options.</span></span>
<a id="line22"></a><span class="lineno">22</span><span class="line"><span class="py-string">    The typical call will start with the name of the processor to be executed,</span></span>
<a id="line23"></a><span class="lineno">23</span><span class="line"><span class="py-string">    followed by a set of parameters, followed by non-parameter arguments.</span></span>
<a id="line24"></a><span class="lineno">24</span><span class="line"><span class="py-string">    All parameters are either of the form 'name=value', or '--name=value'.</span></span>
<a id="line25"></a><span class="lineno">25</span><span class="line"><span class="py-string">    The first form expects 'value' to be valid python, the second a string.</span></span>
<a id="line26"></a><span class="lineno">26</span><span class="line"><span class="py-string">    The remaining non-parameter arguments are associated with the 'input'</span></span>
<a id="line27"></a><span class="lineno">27</span><span class="line"><span class="py-string">    parameter.</span></span>
<a id="line28"></a><span class="lineno">28</span><span class="line"><span class="py-string">    Once this initialization is done, the named command's 'process' method</span></span>
<a id="line29"></a><span class="lineno">29</span><span class="line"><span class="py-string">    is executed.</span></span>
<a id="line30"></a><span class="lineno">30</span><span class="line"><span class="py-string">    &quot;&quot;&quot;</span></span>
<a id="line31"></a><span class="lineno">31</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">    <span class="py-comment">#first make sure the function was called with the correct argument types</span></span>
<a id="line33"></a><span class="lineno">33</span><span class="line">    <span class="py-keyword">for</span> c <span class="py-keyword">in</span> commands:</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> isinstance(commands[c], Processor):</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">            error(<span class="py-string">&quot;command '%s' isn't a valid processor&quot;</span>%c)</span>
<a id="line36"></a><span class="lineno">36</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">    <span class="py-keyword">if</span> len(argv) &lt; 2:</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">        error(<span class="py-string">&quot;Usage : %s &lt;command&gt; [args] [input files]&quot;</span>%argv[0])</span>
<a id="line39"></a><span class="lineno">39</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">    <span class="py-keyword">elif</span> argv[1] == <span class="py-string">'--help'</span>:</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        <span class="py-keyword">print</span> <span class="py-string">&quot;Usage: %s --help&quot;</span>%argv[0]</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">        <span class="py-keyword">print</span> <span class="py-string">&quot;   or: %s &lt;command&gt; --help&quot;</span>%argv[0]</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">        <span class="py-keyword">print</span> <span class="py-string">&quot;   or: %s &lt;command&gt; [parameters]&quot;</span>%argv[0]</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">        <span class="py-keyword">print</span> <span class="py-string">&quot;&quot;</span></span>
<a id="line45"></a><span class="lineno">45</span><span class="line">        <span class="py-keyword">print</span> <span class="py-string">&quot;Available commands:&quot;</span></span>
<a id="line46"></a><span class="lineno">46</span><span class="line">        <span class="py-keyword">for</span> c <span class="py-keyword">in</span> commands:</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">&quot;   %s&quot;</span>%c</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">        sys.exit(0)</span>
<a id="line49"></a><span class="lineno">49</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">    command = argv[1]</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">    args = argv[2:]</span>
<a id="line52"></a><span class="lineno">52</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">    <span class="py-keyword">if</span> <span class="py-string">'--help'</span> <span class="py-keyword">in</span> args:</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">        <span class="py-keyword">print</span> <span class="py-string">&quot;Parameters for command '%s'&quot;</span>%command</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">        parameters = commands[command].get_parameters()</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">        tab = max(map(<span class="py-keyword">lambda</span> x:len(x), parameters.keys()))</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">        <span class="py-keyword">for</span> p <span class="py-keyword">in</span> parameters:</span>
<a id="line58"></a><span class="lineno">58</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">&quot;   %-*s     %s&quot;</span>%(tab, p, parameters[p].doc)</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">        sys.exit(0)</span>
<a id="line60"></a><span class="lineno">60</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">    props = {}</span>
<a id="line62"></a><span class="lineno">62</span><span class="line">    <span class="py-comment"># process all option arguments...</span></span>
<a id="line63"></a><span class="lineno">63</span><span class="line">    <span class="py-keyword">for</span> o, a <span class="py-keyword">in</span> get_options(args): props[o.replace(<span class="py-string">'-'</span>, <span class="py-string">'_'</span>)] = a</span>
<a id="line64"></a><span class="lineno">64</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">    <span class="py-comment"># ...and keep remaining (non-option) arguments as 'input'</span></span>
<a id="line66"></a><span class="lineno">66</span><span class="line">    <span class="py-keyword">if</span> args: props[<span class="py-string">'input'</span>] = args</span>
<a id="line67"></a><span class="lineno">67</span>
<a id="line68"></a><span class="lineno">68</span><span class="line">    <span class="py-keyword">if</span> command <span class="py-keyword">in</span> commands:</span>
<a id="line69"></a><span class="lineno">69</span><span class="line">        ir = IR.IR()</span>
<a id="line70"></a><span class="lineno">70</span><span class="line">        <span class="py-keyword">try</span>:</span>
<a id="line71"></a><span class="lineno">71</span><span class="line">            commands[command].process(ir, **props)</span>
<a id="line72"></a><span class="lineno">72</span><span class="line">        <span class="py-keyword">except</span> Error, e:</span>
<a id="line73"></a><span class="lineno">73</span><span class="line">            error(str(e))</span>
<a id="line74"></a><span class="lineno">74</span><span class="line">        <span class="py-keyword">except</span> KeyboardInterrupt, e:</span>
<a id="line75"></a><span class="lineno">75</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">'KeyboardInterrupt'</span></span>
<a id="line76"></a><span class="lineno">76</span><span class="line">        <span class="py-keyword">except</span> IOError, e:</span>
<a id="line77"></a><span class="lineno">77</span><span class="line">            error(str(e))</span>
<a id="line78"></a><span class="lineno">78</span><span class="line">    <span class="py-keyword">else</span>:</span>
<a id="line79"></a><span class="lineno">79</span><span class="line">        error(<span class="py-string">'no command &quot;%s&quot;'</span>%command)</span>
<a id="line80"></a><span class="lineno">80</span>
<a id="line81"></a><span class="lineno">81</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
